Type BMPHeaderType
    id As String * 2 'Should be "BM"
    size As Long 'Size of the data
    rr1 As Integer '
    rr2 As Integer '
    offset As Long 'Position of start of pixel data
    horz As Long '
    wid As Long 'Image width
    hei As Long 'Image height
    planes As Integer '
    bpp As Integer 'Should read 8 for a 256 colour image
    pakbyte As Long '
    imagebytes As Long 'Width*Height
    xres As Long '
    yres As Long '
    colch As Long '
    ic As Long '
    pal As String * 1024 'Stored as &amp;lt;Blue, Green, Red, 0&amp;gt;
End Type
$Console
$ScreenHide
_Source _Console
_Dest _Console
Dim BmpHeader As BMPHeaderType
Dim SCANLINE As String * 320


If Command$ = "" Then
    Print "USAGE:   img2Bvload  IMAGETOCONVERT.EXT"
    End
End If

Print "CREATING INTERMEDIATE IN.BMP"
Mycomm$ = "magick " + Command$ + " -resize 320x240! -flip -compress none -depth 8 -type palette BMP3:IN.BMP"

Shell Mycomm$

Open "IN.BMP" For Binary As #1

Get #1, , BmpHeader

If BmpHeader.wid <> 320 Or BmpHeader.hei <> 240 Then
    Print "IMPROPER DIMENSIONS TO CONVERT"
    End
End If

' Don't close the file just yet - we're not finished!

Rem  Here's how to convert the 24 bit Pallette to a 12 bit one.

Print "CONVERTING PALLETTE"
Open "VPAL.BIN" For Binary As #2

a$ = BmpHeader.pal ' Pal is stored in a 1024 character string

I% = 1
For PI% = 1 To 256
    b% = Asc(Mid$(a$, I%, 1)) \ 16 'blue
    g% = Asc(Mid$(a$, I% + 1, 1)) \ 16 'green
    r% = Asc(Mid$(a$, I% + 2, 1)) \ 16 'red
    ' I% + 3 is set to zero.
    gb% = Int((g% * 16) + b%)
    gb$ = Chr$(gb%)
    r$ = Chr$(r%)
    Put #2, , gb$
    Put #2, , r$
    I% = I% + 4
Next PI%
Close #2
Print "VPAL.BIN DONE"

Open "IMG.BIN" For Binary As #2

Print "CONVERTING IMAGE DATA"
For X% = 1 To 240
    Get #1, , SCANLINE
    Put #2, , SCANLINE
Next X%

Close #2
Close #1
Print "CONVERSION COMPLETE"
Print "DELETING IN.BMP"
Shell "del IN.BMP"
Print "DONE"
End

